#include "ConfigureManager.h"
#include "ExceptionManager.h"
#include "XmlManager.h"


using namespace CloudResourceManager;
using namespace std;

char ConfigureManager::appSettingPath[1024];
StringMap ConfigureManager::hashTable;

/*
string AppConfigureManager::userScriptPath = ConfigureManager::AppSettings("userScriptPath");//("userScriptPath");
string AppConfigureManager::userSubmitPath = ConfigureManager::AppSettings("userSubmitPath");// "H:\\s3operation\\";
string AppConfigureManager::userTemplatePath = ConfigureManager::AppSettings("userTemplatePath");// "F:\\My Dropbox\\CloudResourceManager\\CloudResourceManager\\SubFiles\\";
string AppConfigureManager::userBatchPath = ConfigureManager::AppSettings("userBatchPath");
string AppConfigureManager::userDataPath = ConfigureManager::AppSettings("userDataPath");
*/

string ConfigureManager::AppSettings(const string& key)
{
    if (appSettingPath[0] == '\0')
    {
        readlink("/proc/self/exe", appSettingPath, sizeof(appSettingPath));
        strcpy(appSettingPath + strlen(appSettingPath), ".xml");
        XmlManager::GetHashTableHelper(appSettingPath, hashTable);
    }
    StringMap::const_iterator it = hashTable.find(key);

    if (it != hashTable.end())
    {
        return it->second;
    }
    else
    {
        string errMsg = "cannot find app setting of ";
        errMsg += key;
        //debugging..
        FILE_LOG(logERROR)<<errMsg;
        for (it = hashTable.begin(); it != hashTable.end(); it ++)
        {
            FILE_LOG(logDEBUG)<<"key="<<it->first<<";value="<<it->second;
        }
        throw XmlException(errMsg);
    }
}

string ConfigureManager::Get(const string& strPlatform, const string& key)
{
    return XmlManager::Get(strPlatform, key);
}

ConfigureManager::~ConfigureManager()
{
    FILE_LOG(logDEBUG)<<"~ConfigureManager";
}
