#include <iostream>
#include "log.h"
#include "XmlManager.h"
#include "TemplateManager.h"
#include "myEC2.h"
#include "ConfigureManager.h"
#include "EC2Manager.h"
#define MYSQLPP_SSQLS_NO_STATICS
#include "RenderingMax.h"
#include "EmailManager.h"

#include <sys/socket.h>       /* for AF_INET */
#include <netdb.h>
#include <arpa/inet.h>
#include <unistd.h>
#include "Blender_RenderManager.h"
#include "StringManager.h"
#include "ScriptManager.h"
#include "CondorManager.h"



using namespace std;
using namespace CloudResourceManager;
void test1()
{
    StringPairVector result;
    MyEC2 my;

    if (my.call(1, "Action", "DescribeRegions"))
    {
        result = my.getResult();
        int len = result.size();
        for (int i = 0; i < len; i ++)
        {
            printf("%s: %s\n", result[i].first.c_str(), result[i].second.c_str());
        }
    }

}

void test3()
{
    /*
    EC2Manager ec2;

    string result, requestId;
    if (!ec2.ec2_request_spot_instance("ami-92dd2bfb", "t1.micro", requestId))
    {
        return -1;
    }
    cout<<"requestId="<<requestId<<endl;
    string state;
    do
    {
        if (EC2Manager::ec2_check_spot_instance_request(requestId, state))
        {
            cout<<"state="<<state<<endl;
            sleep(5);
        }
    }
    while (state.compare("active") != 0);

    string instanceId;
    while (instanceId.size() == 0)
    {
        instanceId = ec2.ec2_get_instance_id(requestId);
        cout<<"instanceId="<<instanceId<<endl;
        sleep(5);
    }

    cout<<"instanceId="<<instanceId<<endl;
    string instanceIp;
    while (instanceIp.size() == 0)
    {
        instanceIp = ec2.ec2_get_instance_ip(instanceId);
        cout<<"instanceIp="<<instanceIp<<endl;
        sleep(5);
    }

    cout<<"instanceIp="<<instanceIp<<endl;

    if (ec2.ec2_destroy_instance(instanceId))
    {
        cout<<"ec2_destroy_instance=success"<<endl;
    }
    */

}
void test2()
{
    XmlManager xmlManager;
    TemplateManager templateManager;
    ConfigureManager configureManager;
    CloudResourceManager::StringMap hashTable, jobContext;
    string strFileName = ConfigureManager::AppSettings("StaticSettingFile");
    cout<<strFileName<<endl;
    string path = ConfigureManager::AppSettings("StaticSettingFile");
    strFileName = path + ".ubuntu32";
    jobContext.insert(StringStringPair("task", "taskOne"));
    jobContext.insert(StringStringPair("job", "jobOne"));
    jobContext.insert(StringStringPair("frame", "frameOne"));
    XmlManager::GetHashTableHelper(strFileName, hashTable);
    string src = ConfigureManager::AppSettings("userTemplatePath") + "/Blender_Render_Template.sub";
    string dst = ConfigureManager::AppSettings("userSubmitPath") + "/Blender_Render_Template.sub";
    TemplateManager::ReplaceTemplateFile(src, dst, hashTable, jobContext);
}

int test4()
{
    EC2Manager ec2;

    string status;
    ec2.ec2_check_instance_status("i-925797fd", status);
    cout<<"status="<<status<<endl;

    //string userScriptPath = ConfigureManager::AppSettings("userScriptPath");
    return 0;
}

void test5()
{
    MySqlppHelper myHelper;
    Users user;
    if (myHelper.GetUsersById(1, user))
    {
        myHelper.ShowUsers(user);
    }
    UserCredits_View userCredits_View;
    if (myHelper.GetUserCredits_ViewById(1, userCredits_View))
    {
        myHelper.ShowUserCredits_View(userCredits_View);
    }
}

void test6()
{
    EmailManager mail;
    mail.SendReportMail("nickhuang99@gmail.com", "hello this is test 6", "I was testing now...");
}

void test7()
{
    string requestId;
    if (EC2Manager::ec2_request_spot_instance("ami-9c07f1f5", "m1.small", requestId))
    {
        string state;
        do
        {
            if (EC2Manager::ec2_check_spot_instance_request(requestId, state))
            {
                cout<<"request status:"<< state<<endl;
                if (state.compare("active")==0)
                {
                    break;
                }
            }
            sleep(5);
        }
        while (true);
        string instanceId;
        if (EC2Manager::ec2_get_instance_id(requestId, instanceId))
        {
            do
            {
                string status;
                if (EC2Manager::ec2_check_instance_status(instanceId, status))
                {
                    cout<<"instance status:"<<status<<endl;
                    if (status.compare("running")==0)\
                    {
                        break;
                    }
                }
                sleep(5);
            }
            while (true);
        }
    }
}

void test8()
{
    string requestId = "sir-1286f614";
    string instanceId;
    if (EC2Manager::ec2_get_instance_id(requestId, instanceId))
    {
        do
        {
            string status;
            if (EC2Manager::ec2_check_instance_status(instanceId, status))
            {
                cout<<"instance status:"<<status<<endl;
                if (status.compare("running")==0)\
                {
                    break;
                }
            }
            sleep(5);
        }
        while (true);
    }
}

void test10()
{
    if (EC2Manager::ec2_destroy_instance("i-16bc3879"))
    {
        cout<<"destroy instance success"<<endl;
    }
}


#ifdef NOWAYFORME
int gethostbyname_r(const char *name,
                    struct hostent *ret, char *buf, size_t buflen,
                    struct hostent **result, int *h_errnop);

struct hostent
{
    char  *h_name;            /* official name of host */
    char **h_aliases;         /* alias list */
    int    h_addrtype;        /* host address type */
    int    h_length;          /* length of address */
    char **h_addr_list;       /* list of addresses */
}
#endif

void test11()
{

    char* host = "ec2.amazonaws.com";
    //临时变量
    char                        dns_buff[8192];
    struct hostent                hostinfo, *phost;
    struct sockaddr_in        addr4;
    int                        i, flag, rc;

    time_t                        now;

    srand(time(NULL));
    //尝试直接转换
    bzero(&addr4, sizeof(struct sockaddr_in));

    int counter = 100;
    do
    {
        //查询DNS
        int result;
        if ((result=gethostbyname_r(host, &hostinfo, dns_buff, 8192, &phost, &rc)) == 0)
        {
            char ipBuffer[256];
            for (char**pptr = phost->h_addr_list; *pptr!=NULL; pptr++)
            {
                inet_ntop(phost->h_addrtype, (u_int32_t*)(*pptr), ipBuffer, sizeof(ipBuffer));
                std::cout << ipBuffer << std::endl;
            }

        }
        else
        {
            extern int h_errno;
            cout<<"\n failed\n"<<endl;
            switch (h_errno)
            {
            case HOST_NOT_FOUND:
                cout<<"HOST_NOT_FOUND";
                break;
            case NO_ADDRESS:
                cout <<"NO_DATA or NO_ADDRESS";
                break;
            case NO_RECOVERY:
                cout<<"NO_RECOVERY";
                break;
            case TRY_AGAIN:
                cout<<"TRY_AGAIN";
                break;
            default:
                cout<<"unknown";
            }
            cout<<endl;
        }
        if (result == 0 || (result != 0&& h_errno != TRY_AGAIN))
        {
            unsigned int usec = rand()%1000000;
            usleep(usec);
            //sleep(4);
            counter --;
        }
    }
    while (counter>0);
}

void test12()
{
    MyEC2 my;
    for (int i = 0; i < 30; i ++)
    {
        if (my.call(1, "Action", "DescribeInstances"))
        {
            StringPairVector result;
            result = my.getResult();
            int len = result.size();
            for (int i = 0; i < len; i ++)
            {
                printf("%s: %s\n", result[i].first.c_str(), result[i].second.c_str());
            }
        }
    }
}

void test13()
{
    MySqlppHelper mySqlppHelper;
    Tasks myTask;
    int taskId=0;
    myTask.UserId = 1;
    myTask.TaskTypeId = TaskTypeEnum::Blender_Rendering;
    myTask.TaskStatusId = TaskStatusEnum::New;
    myTask.TaskInputParameter = "1:2:JPEG";
    myTask.TaskInputFolder = "/home/renderingmax/data/nickhuang99";
    //myTask.TaskOutputFolder = "home/renderingmax/output";
    //myTask.TaskMainFile = "/home/renderingmax/data/nickhuang99/BigBunnyData/production/scenes/01_intro/01.blend";
    myTask.TaskMainFile = "/home/renderingmax/data/nickhuang99/BigBunnyData/production/scenes/01_intro/04.blend";
    myTask.MaxInstanceNumber=1;
    myTask.SpotInstance = true;
    myTask.EC2InstanceTypeId = 3;
    //myTask.LastCheckTime = mysqlpp::sql_datetime(time(NULL));
    //myTask.EC2SnapshotId= "EC2SnapshotId ";
    //myTask.TaskDesc = "TaskDesc";
    //myTask.TaskComment = "TaskComment";
    myTask.CreatedBy = 1;
    myTask.ModifiedOn = mysqlpp::sql_datetime(time(NULL));
    //myTask.ModifiedBy = 1;
    myTask.NotificationTypeId = NotificationTypeEnum::Email;


    if ((taskId=mySqlppHelper.SaveNewTasks(myTask))!= 0)
    {
        cout<<"taskId:"<<taskId<<endl;
        //myTask.TaskId=taskId;
        Tasks newTask;
        try
        {
            if (mySqlppHelper.GetTasksById(taskId, newTask))
            {
                mySqlppHelper.ShowTasks(newTask);
            }
        }
        catch (mysqlpp::Exception e)
        {
            cout<<e.what()<<endl;
        }
    }
}


void test14()
{
    MySqlppHelper mySqlppHelper;
    Users user;
    user.UserName = "nick huang";
    user.LastActivityDate=mysqlpp::sql_datetime(time(NULL));
    user.Credits = 10000;
    user.password = "adflsflslfkfkskfs";
    user.email = "nickhuang99@hotmail.com";
    int userId;
    if ((userId = mySqlppHelper.SaveNewUsers(user))!=0)
    {
        Users newUser;
        if (mySqlppHelper.GetUsersById(userId, newUser))
        {
            mySqlppHelper.ShowUsers(newUser);
        }
    }
}

void test15()
{
    MySqlppHelper mySqlppHelper;
    Jobs job;

    job.TaskId = 2;
    job.JobStatusId= JobStatusEnum::New;
    job.CondorJobId ="condor_JobId";
    job.JobTypeId = JobTypeEnum::BlenderRender;
    job.JobOutPutFolder = "my output folder";
    job.JobInputFolder = "/home/renderingmax/data/nickhuang99";
    job.JobInputMainFile = "/home/renderingmax/data/nickhuang99/BigBunnyData/production/scenes/01_intro/04.blend";
    job.JobStartTime = mysqlpp::sql_datetime(time(NULL));
    job.JobRunTime = 0;
    job.LastCheckTime = mysqlpp::sql_datetime(time(NULL));
    job.JobInputParameter= "1:2:JPEG";
    int jobId;
    if ((jobId = mySqlppHelper.SaveNewJobs(job))!=0)
    {
        Jobs newJob;
        if (mySqlppHelper.GetJobsById(jobId, newJob))
        {
            mySqlppHelper.ShowJobs(newJob);
        }
    }
}

void test16()
{
    Blender_RenderManager myRender;
    if (myRender.SubmitRenderJob(1, "1", "JPEG"))
    {
        cout<<"success!"<<endl;
    }
}


void test17()
{
    Tasks_View taskView;
    MySqlppHelper mySqlppHelper;
    try
    {
        if (mySqlppHelper.GetTasks_ViewById(1, taskView))
        {
            cout<<"good"<<endl;
        }
    }
    catch (mysqlpp::Exception e)
    {
        cout<<e.what()<<endl;
    }
}

void test18()
{
    test14();
    test13();
    test17();
}

void test19()
{
    string str = StringManager::int2string(4);
    cout<<str<<endl;
}

void test20()
{
    StringVector results = ScriptManager::runscript("/usr/bin/condor_submit", "/home/renderingmax/submit/Render_Task1_Job13.sub");
    for (int i = 0; i < results.size(); i ++)
    {
        cout<<"["<<i<<"]"<<results[i]<<endl;
    }
}

void test21()
{
    StringVector results = ScriptManager::runscript("/home/nick/myprojects/mytest/bin/Debug/mytest", "");
    for (int i = 0; i < results.size(); i ++)
    {
        cout<<"["<<i<<"]"<<results[i]<<endl;
    }
}

void test22()
{
    StringVector results = CondorManager::get_ip();
    for (int i = 0; i < results.size(); i ++)
    {
        cout<<"["<<i<<"]"<<results[i]<<endl;
    }
}

void test23()
{
    string result = ScriptManager::runscript("/home/nick/myprojects/mytest/bin/Debug/mytest");
    cout << result <<endl;
}

string createString()
{
    stringstream stream;
    stream <<"this is a string";
    return stream.str();
}

void test24()
{
    cout << createString()<<endl;
}

void test25()
{
    if (CondorManager::config_taskId("192.168.0.106", "1"))
    {
        cout<<"config_taskId success"<<endl;
        if (CondorManager::config_taskStatus("192.168.0.106", "3"))
        {
            cout<<"config_taskStatus success"<<endl;
        }
    }
}

void test26()
{
    StringVector results = CondorManager::find_idle_ip();
    for (int i = 0; i < results.size(); i ++)
    {
        cout<<"["<<i<<"]"<<results[i]<<endl;
    }
}

void test27()
{
    string status;
    string jobId = "28.";
    int result = CondorManager::find_job_array(jobId, status);
    if (result != -1)
    {
        cout<<"jobid:"<<jobId<<" status:"<<status<<" running time:"<<result<<endl;
    }
}

void test28()
{
    if (CondorManager::check_active_instance("192.168.0.106"))
    {
        cout<<"success"<<endl;
    }
}

void test29()
{
    Blender_RenderManager myRender;
    if (myRender.InitiateTask(1))
    {
        cout<<"success!"<<endl;
    }
}

void test30()
{
    string str = "39.";
    int num;
    if (StringManager::string2int(str, num))
    {
        cout<<num<<endl;
    }
}

void test31()
{
    Blender_RenderManager myRender;
    Tasks myTask;
    MySqlppHelper mySqlppHelper;
    if (mySqlppHelper.GetTasksById(1, myTask))
    {
        int result = myRender.GenerateRenderJobs(myTask);
        cout<<"generate jobs:"<<result<<endl;
    }
}

void test32()
{
    Blender_RenderManager myRender;
    if (myRender.InitiateInstanceByTask(1))
    {
        cout<<"success"<<endl;
    }
}


int main(int argc, char *argv[])
{
    test13();
    test29();
    test32();
    test31();
    return 0;
}
