#ifndef MAINMENUWIDGET_H_INCLUDED
#define MAINMENUWIDGET_H_INCLUDED

#include <Wt/WCompositeWidget>
#include <Wt/WTable>
#include <Wt/WMenu>
#include <Wt/WMenuItem>

namespace Wt
{
    class WTable;
    class WCompositeWidget;
    class WContainerWidget;
    class WMenuItem;
}

using namespace Wt;

class MainMenuWidget : public WCompositeWidget
{
public:
    MainMenuWidget(WContainerWidget *parent = 0);
    void addItem(const WString& strName, WWidget* widget);
    void setWidth(size_t width);
    void setHeight(size_t height);
    void setTitle(const std::string& strTitle);
    bool selectByName(const std::string& strName);
    bool setHiddenByName(const std::string& strName, bool bHidden);
    bool setDisabledByName(const std::string& strName, bool bDisabled);
    bool removeItem(WWidget* widget);
private:
    WTable             *m_layout;
    WPanel             *m_panel;
    WMenu              *m_menu;
    std::string         m_title;
    size_t              m_width;
    size_t              m_height;
    void doResize();
    void menuItemSelected(WMenuItem* menuItem);
    WMenuItem* findItemByName(const std::string& strName);
};


#endif // MAINMENUWIDGET_H_INCLUDED
