#ifndef SUBMITWIDGET_H_INCLUDED
#define SUBMITWIDGET_H_INCLUDED
#include <Wt/WSpinBox>
#include <Wt/WComboBox>
#include <Wt/DBEnumComboBox.h>
#include <Wt/WContainerWidget>
#include <Wt/FileTreeView.h>
#include <Wt/WPushButton>
#include "NotifyEvent.h"


namespace Wt
{
    class WContainerWidget;
    class WSpinBox;
    class WComboBox;
    class WLineEdit;
    class WPushButton;
}
using namespace Wt;

class SubmitWidget : public WContainerWidget
{
public:
    SubmitWidget(const std::string& strFolderName, WContainerWidget *parent = 0);
    void setupNotifyEventMethod(NotifyMethod notifyMethod, WObject* notifyObj);
private:
    WContainerWidget  *m_parent;
    std::string        m_folderName;
    WSpinBox          *instanceNumberBox;
    WComboBox         *outputFormatBox;
    DBEnumComboBox    *instanceTypeBox;
    WSpinBox          *startFrameBox;
    WSpinBox          *endFrameBox;
    FileTreeView      *fileTreeView;
    WPushButton       *submitButton;
    WPushButton       *summaryButton;
    WText             *msg;
    WText             *endFrameMsg;
    WText             *fileTreeViewMsg;
    NotifyMethod       m_notifyMethod;
    WObject           *m_notifyObj;
    void validateFrameNumber(int ignore);
    void summary();
    void submit();
};


#endif // SUBMITWIDGET_H_INCLUDED
