#ifndef UPLOADFILEWIDGET_H_INCLUDED
#define UPLOADFILEWIDGET_H_INCLUDED

#include <Wt/WCompositeWidget>
#include <Wt/WTable>
#include <Wt/WFileUpload>
#include <Wt/WProgressBar>
#include <Wt/WPushButton>
#include <Wt/WText>
#include <Wt/WWebWidget>
#include <Wt/WContainerWidget>
#include <Wt/WPanel>
#include <Wt/WApplication>


namespace Wt
{
    class WTable;
    class WCompositeWidget;
    class WContainerWidget;
    class WFileUpload;
    class WProgressBar;
    class WPushButton;
    class WText;
    class WPanel;
    class WApplication;
}

using namespace Wt;

class UploadFileWidget: public WCompositeWidget
{
public:
    UploadFileWidget(WContainerWidget*parent = NULL);
    ~UploadFileWidget();
private:
    WFileUpload *m_fileUpload;
    WTable      *m_layout;
    WProgressBar*m_progress;
    //WPushButton *m_uploadButton;
    WPushButton *m_selectButton;
    WText       *m_msg;

    static char *ClickToUploadText;
    static char *ClickToSelectText;
    static char *ClickToStartText;
    //WPanel      *m_panel;
    void initialize();
    void fileUploaded();
    void fileTooLarge(int nFileSize);
    void uploadFile();

};

#endif // UPLOADFILEWIDGET_H_INCLUDED
